
#############################################################
# Author: Michael Tomz
# Date: Dec 20, 2001
# Format: SPlus 2000 Command File
# Purpose: Replicate Figure 3 (EPCP) in Section 5.3
#############################################################

import.data(DataFrame="pcpF", FileName="F:\\ttw\\pcpF.dta", FileType = "STATA")
import.data(DataFrame="pcpFc", FileName="F:\\ttw\\pcpFc.dta", FileType = "STATA")
import.data(DataFrame="pcpP", FileName="F:\\ttw\\pcpP.dta", FileType = "STATA")
import.data(DataFrame="pcpPc", FileName="F:\\ttw\\pcpPc.dta", FileType = "STATA")

 postscript("f:\\ttw\\Fig3a.ps", horizontal=T)
 shift <- .07
 attach(pcpFc)
 par(mar=c(6,6,2,0))
 plot(x-shift,pcpFc2*100,ylim=c(85,100),xlim=c(1,10), pch=16, ylab="", xlab="", axes=F, mkh=.1)
 attach(pcpF)
 points(x+shift,pcpF2*100, pch=4, mkh=.15)
 i <- 1
 while(i<=10)
 {
    lo <- c(i-shift,pcpFc3[i]*100)
    hi <- c(i-shift,pcpFc4[i]*100)
    dta <- rbind(hi,lo)
    lines(dta, lwd=5)    
    lo <- c(i+shift,pcpF3[i]*100)
    hi <- c(i+shift,pcpF4[i]*100)
    dta <- rbind(hi,lo)
    lines(dta, lwd=5)
    i <- i+1
 }
 axis(1,at=c(1,2,3,4,5,6,7,8,9,10), labels=c("59","64","66","70","74F","74O","79","83","87","92"), cex=1.75)
 axis(2,at=c(85,90,95,100), labels=c(85,90,95,100), adj=1, cex=1.75)
 text(5.6,82,"Election", cex=2.2)
 text(-.55,92,"Percent",cex=2.2,srt=90)
 text(.8,101,"Fully Contested",cex=2.2,adj=0)
 dev.off()

 postscript("f:\\ttw\\Fig3b.ps", horizontal=T)
 attach(pcpPc)
 par(mar=c(6,6,2,0))
 plot(x-shift,pcpPc2*100,ylim=c(85,100),xlim=c(1,10), pch=16, ylab="", xlab="", axes=F, mkh=.1)
 attach(pcpP)
 points(x+shift,pcpP2*100, pch=4, mkh=.15)
 i <- 1
 while(i<=10)
 {
    lo <- c(i-shift,pcpPc3[i]*100)
    hi <- c(i-shift,pcpPc4[i]*100)
    dta <- rbind(hi,lo)
    lines(dta, lwd=5)    
    lo <- c(i+shift,pcpP3[i]*100)
    hi <- c(i+shift,pcpP4[i]*100)
    dta <- rbind(hi,lo)
    lines(dta, lwd=5)
    i <- i+1
 }
 axis(1,at=c(1,2,3,4,5), labels=c("59","64","66","70","74F"), cex=1.75)
 axis(2,at=c(85,90,95,100), labels=c(85,90,95,100), adj=1, cex=1.75)
 text(3,82,"Election", cex=2.2)
 text(.8,101,"Partially Contested",cex=2.2,adj=0)
 dev.off()

detach("pcpF")
detach("pcpFc")
detach("pcpP")
detach("pcpPc")

